diff --git a/test/unit/stages/review/fix_completion_fallback_test.rb b/test/unit/stages/review/fix_completion_fallback_test.rb
new file mode 100644
index 0000000..985d697
--- /dev/null
+++ b/test/unit/stages/review/fix_completion_fallback_test.rb
@@ -0,0 +1,398 @@
+require "test_helper"
+require "json"
+require "hive/stages/review"
+require "hive/claude_launcher"
+require "hive/stages/completion_evidence"
+require "hive/task"
+
+# Acceptance coverage for the review-fix tolerant-completion fallback (U3).
+#
+# Brainstorm examples mapped 1:1:
+#   1. Clean exit + artifacts + HEAD moved   => fallback envelope (:ok),
+#      stage reaches write_fix_success / REVIEW_COMPLETE, NO review_error
+#      marker, claude_completion_fallback present in events.jsonl.
+#   2. Crashed / unreadable pane (no exit-code proof)  => strict timeout
+#      envelope => REVIEW_ERROR phase=fix reason=fix_failed preserved.
+#   3. Missing/inconsistent pass artifacts   => strict.
+#   4. Claims code change, HEAD unmoved, no no-change assertion => strict.
+#   5. Explicit no-change resolution         => suppressed via detail Hash.
+#   6. The `fix_failed` marker path and the fallback envelope are mutually
+#      exclusive: agent_failed?(:timeout) drives the marker only when no
+#      fallback metadata landed.
+class ReviewFixCompletionFallbackTest < Minitest::Test
+  include HiveTestHelper
+
+  def setup
+    @prev_bin = ENV["HIVE_CLAUDE_BIN"]
+    @driver_dir = Dir.mktmpdir("review-fallback-driver")
+    @driver_bin = File.join(@driver_dir, "claude")
+    File.write(@driver_bin, <<~SH)
+      #!/usr/bin/env bash
+      if [[ "${1:-}" == "--version" ]]; then
+        echo "2.1.118 (Claude Code)"
+        exit 0
+      fi
+      exit 0
+    SH
+    File.chmod(0o755, @driver_bin)
+    ENV["HIVE_CLAUDE_BIN"] = @driver_bin
+    Hive::AgentProfile.reset_version_cache!
+  end
+
+  def teardown
+    ENV["HIVE_CLAUDE_BIN"] = @prev_bin
+    FileUtils.rm_rf(@driver_dir) if @driver_dir
+    Hive::AgentProfile.reset_version_cache!
+  end
+
+  # --- Evidence factory unit scenarios --------------------------------
+
+  def with_review_fix_setup(accepted_text: nil)
+    with_tmp_dir do |root|
+      task_folder = File.join(root, ".hive-state", "stages", "6-review", "fix-fallback-260629-aaaa")
+      FileUtils.mkdir_p(File.join(task_folder, "reviews"))
+      File.write(File.join(task_folder, "task.md"), "---\nslug: fix-fallback-260629-aaaa\n---\n\n# t\n")
+
+      worktree = Dir.mktmpdir("fix-fallback-wt")
+      run!("git", "-C", worktree, "init", "-b", "feat-x", "--quiet")
+      run!("git", "-C", worktree, "config", "user.email", "t@example.com")
+      run!("git", "-C", worktree, "config", "user.name", "T")
+      run!("git", "-C", worktree, "config", "commit.gpgsign", "false")
+      File.write(File.join(worktree, "seed.txt"), "seed\n")
+      run!("git", "-C", worktree, "add", ".")
+      run!("git", "-C", worktree, "commit", "-m", "init", "--quiet")
+
+      reviews = File.join(task_folder, "reviews")
+      File.write(File.join(reviews, "stub-reviewer-01.md"), "## High\n- [x] fix the thing\n")
+      File.write(File.join(reviews, "escalations-01.md"), "# Escalations for pass 01\n\n_All answered._\n")
+
+      ctx = Hive::Reviewers::Context.new(
+        worktree_path: worktree,
+        task_folder: task_folder,
+        default_branch: "main",
+        pass: 1
+      )
+      accepted = accepted_text ||
+                 Hive::Stages::Review.send(:collect_accepted_findings_with_count, ctx).text
+      refute_predicate accepted, :empty?, "setup sanity: a [x] finding must be collected"
+
+      baseline_head = Hive::Stages::Review.send(:git_head, worktree)
+      evidence = Hive::Stages::Review.send(
+        :fix_completion_evidence, ctx,
+        worktree_path: worktree,
+        before_fix_head: baseline_head,
+        accepted_findings_text: accepted
+      )
+      yield({ root: root, task_folder: task_folder, worktree: worktree,
+              ctx: ctx, evidence: evidence, baseline_head: baseline_head })
+    end
+  end
+
+  def commit_in_worktree!(worktree)
+    File.write(File.join(worktree, "applied.txt"), "fix applied to cited line\n")
+    run!("git", "-C", worktree, "add", "applied.txt")
+    run!("git", "-C", worktree, "commit", "-m", "fix(review): apply finding",
+         "--quiet")
+  end
+
+  def test_evidence_proves_completion_when_head_moved_with_consistent_artifacts
+    with_review_fix_setup do |s|
+      accepted_before = Hive::Stages::Review.send(:collect_accepted_findings_with_count, s[:ctx]).text
+      refute_predicate accepted_before, :empty?, "setup sanity: a [x] finding must be collected"
+
+      commit_in_worktree!(s[:worktree])
+
+      detail = s[:evidence].call({ pane_tail: "all done" })
+
+      assert detail, "HEAD moved + consistent artifacts + readable worktree must prove completion"
+      assert_equal "fix", detail.fetch(:phase)
+      assert_equal 1, detail.fetch(:pass)
+      assert_match(/HEAD moved/, detail.fetch(:commit_evidence))
+      assert_match(/docs parse/, detail.fetch(:artifacts))
+    end
+  end
+
+  def test_evidence_strict_when_pass_artifacts_missing_or_inconsistent
+    with_review_fix_setup do |s|
+      commit_in_worktree!(s[:worktree])
+
+      # Inconsistent: reviewer file changed after the orchestrator computed
+      # the accepted set — tamper-like drift fails strictly.
+      File.write(File.join(s[:task_folder], "reviews", "stub-reviewer-01.md"), "## High\n- [x] different text\n")
+      assert_nil_or_false(s[:evidence].call({ pane_tail: "" }),
+                          "artifact drift against the pre-spawn accepted set must be strict")
+    end
+
+    with_review_fix_setup do |s|
+      commit_in_worktree!(s[:worktree])
+      FileUtils.rm_f(File.join(s[:task_folder], "reviews", "escalations-01.md"))
+      assert_nil_or_false(s[:evidence].call({ pane_tail: "" }),
+                          "missing escalations doc must be strict even when HEAD moved")
+    end
+  end
+
+  def test_evidence_strict_when_claims_changes_but_head_unmoved_without_assertion
+    with_review_fix_setup do |s|
+      # No commit in the worktree; tail does not state a resolution.
+      assert_nil_or_false(s[:evidence].call({ pane_tail: "worked hard, tests green" }),
+                          "hollow pass (no commit, no assertion) must stay strict")
+    end
+  end
+
+  def test_evidence_accepts_explicit_no_change_resolution_assertion
+    with_review_fix_setup do |s|
+      detail = s[:evidence].call(
+        { pane_tail: "Checked all findings: No code changes were needed; every finding was already resolved." }
+      )
+
+      assert detail, "an explicit no-change assertion may stand in for commit evidence"
+      assert_match(/no-change/, detail.fetch(:commit_evidence))
+    end
+  end
+
+  def test_evidence_strict_on_new_unresolved_escalation_state
+    with_review_fix_setup do |s|
+      commit_in_worktree!(s[:worktree])
+      # Orchestrator-owned escalation doc gained a pending question since spawn.
+      File.write(
+        File.join(s[:task_folder], "reviews", "escalations-01.md"),
+        "# Escalations for pass 01\n\n### Q2. New?\n### A2.\n"
+      )
+
+      assert_nil_or_false(s[:evidence].call({ pane_tail: "" }),
+                          "new pending-escalation drift after spawn must be strict")
+    end
+  end
+
+  def test_evidence_strict_when_worktree_becomes_unreadable
+    with_review_fix_setup do |s|
+      stale_worktree = File.join(s[:ctx].worktree_path, "..", "deleted-now")
+      FileUtils.mv(s[:ctx].worktree_path, stale_worktree) rescue nil
+      begin
+        FileUtils.rm_rf(stale_worktree)
+
+        assert_nil_or_false(s[:evidence].call({ pane_tail: "" }),
+                            "unreadable worktree can never prove completion")
+      ensure
+        FileUtils.mkdir_p(s[:ctx].worktree_path)
+      end
+    end
+  end
+
+  def test_no_change_predicate_stays_conservative
+    [
+      ["No code changes were needed.", true],
+      ["All findings were already resolved before this pass.", true],
+      ["Nothing to fix; skip both findings as unimplementable here (no changes needed)", true],
+      ["I changed three files and added tests.", false],
+      ["Committed fixes for findings 1 and 2.", false],
+      ["", false]
+    ].each do |tail, expected|
+      assert_equal expected, Hive::Stages::CompletionEvidence.explicit_no_change?(tail),
+                   "#{tail.inspect} should be explicit_no_change?=#{expected}"
+    end
+  end
+
+  # --- End-to-end through the real launcher conversion -----------------
+
+  def with_spawn_stub(simulate)
+    captured = { kwargs: nil }
+    original = Hive::Stages::Base.singleton_class.instance_method(:spawn_claude!)
+    Hive::Stages::Base.define_singleton_method(:spawn_claude!) do |spawn_task, cfg, **kwargs|
+      captured[:kwargs] = kwargs
+      simulate.call(spawn_task, kwargs)
+    end
+    yield captured
+  ensure
+    Hive::Stages::Base.singleton_class.send(:define_method, :spawn_claude!, original) if original
+  end
+
+  # Real conversion: prepares claude_exit_code=0 + optionally commits, then
+  # runs the actual ClaudeLauncher gate with the REAL evidence closure so the
+  # acceptance line exercises the same code tmux runs.
+  def simulate_clean_exit_spawn!(task, kwargs, commit:, tail:)
+    worktree = kwargs[:cwd]
+    commit_in_worktree!(worktree) if commit
+    File.write(Hive::ClaudeLauncher.exit_code_path(task), "0\n")
+    evidence = kwargs.fetch(:completion_evidence)
+    result = Hive::ClaudeLauncher.maybe_complete_without_done_signal(
+      task, nil, tail, kwargs[:log_label], evidence
+    )
+    return result if result
+
+    # The gate refused (strict): reproduce the legacy timeout envelope.
+    { status: :timeout, error_message: "claude stop hook did not signal completion" }
+  end
+
+  def test_clean_exit_with_commit_and_artifacts_completes_stage_via_fallback
+    with_tmp_git_repo do |project|
+      slug = "fix-fallback-e2e"
+      folder = File.join(project, ".hive-state", "stages", "6-review", slug)
+      FileUtils.mkdir_p(File.join(folder, "reviews"))
+      File.write(File.join(folder, "task.md"), <<~MD)
+        ---
+        slug: #{slug}
+        ---
+
+        # #{slug}
+      MD
+      worktree_root = File.join(project, ".wt-root")
+      Dir.mkdir(worktree_root)
+      worktree = File.join(worktree_root, "wt")
+      run!("git", "-C", worktree.split("/wt")[0], "init", "--quiet") if false
+      init_repo_at!(worktree)
+
+      File.write(File.join(folder, "worktree.yml"),
+                 { "path" => worktree, "branch" => "feat" }.to_yaml)
+      File.write(File.join(folder, "reviews", "stub-reviewer-01.md"), "## High\n- [x] fix it\n")
+      File.write(File.join(folder, "reviews", "escalations-01.md"),
+                 "# Escalations for pass 01\n\n_All answered._\n")
+      Hive::Markers.set(File.join(folder, "task.md"), :review_waiting, pass: 1, escalations: 1)
+
+      task = Hive::Task.new(folder)
+      cfg = {
+        "claude" => { "mode" => "tmux" },
+        "default_branch" => "feat",
+        "review" => { "max_passes" => 1, "browser_test" => { "enabled" => false } },
+        "worktree_root" => worktree_root
+      }
+
+      with_spawn_stub(lambda { |spawn_task, kwargs|
+        simulate_clean_exit_spawn!(spawn_task, kwargs, commit: true, tail: "done")
+      }) do
+        capture_io do
+          result = Hive::Stages::Review.run!(task, cfg)
+          assert_equal :review_complete, result[:status],
+                       "clean-exit-with-artifacts must complete the stage via the fallback"
+        end
+      end
+
+      marker = Hive::Markers.current(task.state_file)
+      assert_equal :review_complete, marker.name,
+                   "no terminal REVIEW_ERROR may exist on this path"
+      assert File.exist?(File.join(folder, "reviews", "fix-success-01.md")),
+             "write_fix_success must have landed for pass 1"
+
+      events = File.readlines(File.join(folder, "events.jsonl"), chomp: true)
+                   .map { |line| JSON.parse(line) }
+      fallback_events = events.select { |e| e["event_type"] == "claude_completion_fallback" }
+      assert_equal 1, fallback_events.size, "exactly one WARN audit event expected"
+      message = fallback_events.first.fetch("message")
+      assert_includes message, "phase=fix"
+      assert_includes message, "pass=01"
+      assert_includes message, "HEAD moved"
+      assert_includes message, "slug=#{slug}"
+    end
+  end
+
+  def test_hollow_and_crashed_spawns_keep_strict_review_error
+    [
+      # Hollow run: agent claims success in prose but made no commit and no
+      # explicit no-change assertion — strict timeout envelope wins.
+      { name: "hollow-no-commit", commit: false, tail: "worked on it, looks good" },
+      # Crashed/unreadable pane: no claude_exit_code written at all.
+      { name: "crashed-no-exit-code", commit: true, tail: "", crash: true }
+    ].each do |scenario|
+      with_tmp_git_repo do |project|
+        slug = "fix-strict-e2e-#{scenario[:name].tr("_", "-")[0, 40].gsub(/[^a-z0-9-]/, "")}"
+        folder = File.join(project, ".hive-state", "stages", "6-review", slug)
+        FileUtils.mkdir_p(File.join(folder, "reviews"))
+        File.write(File.join(folder, "task.md"), "---\nslug: #{slug}\n---\n\n# x\n")
+        worktree_root = File.join(project, ".wt-root")
+        Dir.mkdir(worktree_root)
+        worktree = File.join(worktree_root, "wt")
+        init_repo_at!(worktree)
+
+        File.write(File.join(folder, "worktree.yml"),
+                   { "path" => worktree, "branch" => "feat" }.to_yaml)
+        File.write(File.join(folder, "reviews", "stub-reviewer-01.md"), "## High\n- [x] fix it\n")
+        File.write(File.join(folder, "reviews", "escalations-01.md"),
+                   "# Escalations for pass 01\n\n_All answered._\n")
+        Hive::Markers.set(File.join(folder, "task.md"), :review_waiting, pass: 1, escalations: 1)
+
+        task = Hive::Task.new(folder)
+        cfg = {
+          "claude" => { "mode" => "tmux" },
+          "default_branch" => "feat",
+          "review" => { "max_passes" => 1, "browser_test" => { "enabled" => false } },
+          "worktree_root" => worktree_root
+        }
+
+        with_spawn_stub(lambda { |spawn_task, kwargs|
+          simulate_strict_spawn(
+            spawn_task, kwargs,
+            commit: scenario[:commit], tail: scenario[:tail], crash: scenario[:crash]
+          )
+        }) do
+          capture_io do
+            result = Hive::Stages::Review.run!(task, cfg)
+            assert_equal :review_error, result[:status], scenario[:name]
+          end
+        end
+
+        marker = Hive::Markers.current(task.state_file)
+        assert_equal :review_error, marker.name, scenario[:name]
+        assert_equal "fix", marker.attrs["phase"], scenario[:name]
+        assert_equal "fix_failed", marker.attrs["reason"], scenario[:name]
+        assert_equal "claude stop hook did not signal completion",
+                     marker.attrs["message"],
+                     "#{scenario[:name]}: the legacy stop-hook message must survive unchanged"
+        refute File.exist?(File.join(folder, "reviews", "fix-success-01.md")),
+               "#{scenario[:name]}: fix-success sentinel must NOT land"
+
+        events = File.readlines(File.join(folder, "events.jsonl"), chomp: true)
+                     .map { |line| JSON.parse(line) }
+        refute events.any? { |e| e["event_type"] == "claude_completion_fallback" },
+               "#{scenario[:name]}: no fallback event without proven completion"
+      end
+    end
+  end
+
+  # --- Mutual exclusivity of fix_failed marker vs fallback envelope ------
+
+  def test_agent_failed_is_exclusive_with_fallback_envelope
+    timeout_envelope = { status: :timeout, error_message: "claude stop hook did not signal completion" }
+    fallback_envelope = {
+      status: :ok,
+      log_label: "l",
+      fallback: { reason: Hive::ClaudeLauncher::FALLBACK_MISSING_SIGNAL_REASON,
+                  exit_code: "0", evidence: "artifacts=a commit_evidence=c" }
+    }
+
+    assert Hive::Stages::Review.agent_failed?(timeout_envelope)
+    assert_nil_or_false(timeout_envelope[:fallback], "timeout envelope carries no fallback")
+    refute Hive::Stages::Review.agent_failed?(fallback_envelope),
+           "the fallback envelope converts the failure into a normal success"
+  end
+
+  private
+
+  def simulate_strict_spawn(task, kwargs, commit:, tail:, crash: false)
+    worktree = kwargs[:cwd]
+    commit_in_worktree!(worktree) if commit
+    unless crash
+      File.write(Hive::ClaudeLauncher.exit_code_path(task), "0\n")
+      result = Hive::ClaudeLauncher.maybe_complete_without_done_signal(
+        task, nil, tail, kwargs[:log_label], kwargs.fetch(:completion_evidence)
+      )
+      return result if result
+    end
+    # Crash leaves no exit-code file AND no conversion: legacy envelope.
+    { status: :timeout, error_message: "claude stop hook did not signal completion" }
+  end
+
+  def init_repo_at!(path)
+    FileUtils.mkdir_p(path)
+    run!("git", "-C", path, "init", "-b", "feat", "--quiet")
+    run!("git", "-C", path, "config", "user.email", "t@example.com")
+    run!("git", "-C", path, "config", "user.name", "T")
+    run!("git", "-C", path, "config", "commit.gpgsign", "false")
+    File.write(File.join(path, "seed.txt"), "seed\n")
+    run!("git", "-C", path, "add", ".")
+    run!("git", "-C", path, "commit", "-m", "init", "--quiet")
+  end
+
+  def assert_nil_or_false(value, message)
+    assert value.nil? || value == false, message
+  end
+end
diff --git a/test/unit/stop_hook_installer_test.rb b/test/unit/stop_hook_installer_test.rb
index 71b2a57..161672b 100644
--- a/test/unit/stop_hook_installer_test.rb
+++ b/test/unit/stop_hook_installer_test.rb
@@ -137,6 +137,44 @@ class StopHookInstallerTest < Minitest::Test
     end
   end
 
+  # Forensic trail for the "hook ran but .done absent" incident class:
+  # every hook invocation appends one append-only line under the task
+  # folder so operators can see whether result.json/.done writes landed.
+  def test_stop_hook_appends_forensics_log_line
+    with_tmp_dir do |dir|
+      Open3.capture3({ "HIVE_TASK_STAGE_DIR" => dir }, HOOK, stdin_data: "{\"status\":\"ok\"}")
+      Open3.capture3({ "HIVE_TASK_STAGE_DIR" => dir }, HOOK, stdin_data: "")
+
+      log_path = File.join(dir, "stop-hook.log")
+      assert File.exist?(log_path), "the hook must leave an observability trail in stop-hook.log"
+      lines = File.readlines(log_path).grep_v(/truncated/)
+      assert_equal 2, lines.size, "one line per Stop-hook invocation"
+      lines.each do |line|
+        assert_match(/stage=#{Regexp.escape(dir)}/, line)
+        assert_match(%r{stdin_bytes=\d+}, line)
+        assert_match(/result_written=(absent|written)/, line)
+        assert_match(/done_written=(yes|no)/, line)
+      end
+    end
+  end
+
+  # The forensics log must never grow without bound (mirrors the orphan-
+  # sweep-log rotation contract).
+  def test_stop_hook_log_rotates_past_size_cap
+    with_tmp_dir do |dir|
+      log_path = File.join(dir, "stop-hook.log")
+      File.write(log_path, "x" * (70 * 1024))
+
+      _out, err, status = Open3.capture3({ "HIVE_TASK_STAGE_DIR" => dir }, HOOK, stdin_data: "{}")
+
+      assert status.success?, err
+      body = File.read(log_path)
+      assert_operator body.bytesize, :<, 70 * 1024, "log must be truncated past the cap"
+      assert_includes body, "(log truncated"
+      assert_includes body, "done_written=yes"
+    end
+  end
+
   def test_stop_hook_requires_stage_dir_env
     # Scrub HIVE_TASK_STAGE_DIR from the child env so the test is hermetic even
     # when the surrounding shell exports it (e.g. under the review harness);
@@ -151,4 +189,54 @@ class StopHookInstallerTest < Minitest::Test
   def test_stop_hook_syntax
     assert system("sh", "-n", HOOK)
   end
+
+  # --- Sentinel-path contract (U4): the installer, the hook script, and
+  # ClaudeLauncher must agree on where the completion signals live. A drift
+  # in any one of them silently re-creates the "stop hook did not signal
+  # completion" incident class this suite pins down.
+
+  TASK_LIKE = Struct.new(:folder)
+
+  def test_hook_sentinels_land_exactly_where_claude_launcher_waits
+    require "hive/claude_launcher"
+    with_tmp_dir do |dir|
+      payload = %({"status":"ok"})
+      _out, err, status = Open3.capture3({ "HIVE_TASK_STAGE_DIR" => dir }, HOOK, stdin_data: payload)
+      assert status.success?, err
+
+      task_like = TASK_LIKE.new(dir)
+      assert File.exist?(Hive::ClaudeLauncher.done_path(task_like)),
+             "the hook's .done write must equal ClaudeLauncher.done_path"
+      assert_equal payload, File.read(Hive::ClaudeLauncher.result_path(task_like)),
+                   "the hook's result.json write must equal ClaudeLauncher.result_path"
+    end
+  end
+
+  def test_wrapper_exit_code_file_matches_claude_launcher_contract
+    require "hive/claude_launcher"
+    wrapper_script = File.expand_path("../../lib/hive/scripts/interactive_claude_wrapper.sh", __dir__)
+    task_like = TASK_LIKE.new("/anywhere")
+
+    assert_includes File.read(wrapper_script),
+                    File.basename(Hive::ClaudeLauncher.exit_code_path(task_like)),
+                    "the wrapper must persist exactly ClaudeLauncher.exit_code_path's basename"
+  end
+
+  def test_installer_stage_dir_env_prefix_drives_the_exact_watch_folder
+    with_tmp_dir do |dir|
+      other_dir = Dir.mktmpdir("installer-contract-other")
+      paths = Hive::StopHookInstaller.install(stage_dir: dir, extra_dirs: [ other_dir ])
+
+      assert_equal 2, paths.size
+      paths.each do |path|
+        command = JSON.parse(File.read(path)).fetch("hooks").fetch("Stop").first.fetch("hooks").first.fetch("command")
+        # H4 guard: a shell-prefixed env assignment that pointed at ANY other
+        # directory would leave sentinels outside ClaudeLauncher's watch folder.
+        assert_includes command, "HIVE_TASK_STAGE_DIR=#{Shellwords.escape(dir)}",
+                        "every install copy must target stage_dir #{dir} (got #{command.inspect})"
+        refute_includes command, Shellwords.escape(other_dir),
+                        "the extra-dir copy is only a discovery surface; it must not retarget the env prefix"
+      end
+    end
+  end
 end
